#
# spec file for package cron (Version 3.0.1)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# neededforbuild  laus laus-devel

BuildRequires:  aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils gcc gdbm gettext laus laus-devel libtool perl rpm

Name:           cron
License:        FSR, Other License(s), see package
Group:          System/Daemons
Requires:       smtp_daemon
Autoreqprov:    on
Version:        3.0.1
Release:        920.12
Summary:        cron daemon
Source:         cron-3.0.1.tar.gz
Source1:        cron.init
Patch:          cron-3.0.1.dif
Patch1:         username_boverflow.dif
Patch2:         setuid.dif
Patch3:         fdleak.dif
Patch4:         crontab_quoting.dif
Patch5:         cron_number_check.patch
Patch6:         cron-%{version}-laus.diff
Patch7:         cron-timing.diff
Patch8:         cron-3.0.1-privilege_escalation.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if %suse_version > 800
PreReq:         %insserv_prereq %fillup_prereq textutils fileutils grep /usr/bin/sed
%endif

%description
Cron automatically starts programs at specific times. Add new entries
with "crontab -e". (See "man 5 crontab" and "man 1 crontab" for
documentation.)

Under /etc you can find the directories cron.hourly, cron.daily,
cron.weekly, and cron.monthly.	Scripts and programs, that are located
there will be started automatically.



Authors:
--------
    Paul Vixie <paul@vix.com>

%prep
%setup
%patch
%patch1
%patch2
%patch3
%patch4
%patch5
%patch6 -p1
%patch7 -p1
%patch8 -p1

%build
make LIBS="/usr/%_lib/liblaus.a" DEFS="-DHAVE_LIBLAUS"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/usr/{bin,sbin}
install -d $RPM_BUILD_ROOT/%_mandir/man{1,5,8}
install -d $RPM_BUILD_ROOT/etc
make DESTDIR=$RPM_BUILD_ROOT install
install -d $RPM_BUILD_ROOT/var/spool/cron
install -d $RPM_BUILD_ROOT/var/spool/cron/tabs
install -d $RPM_BUILD_ROOT/var/spool/cron/lastrun
install -m 600 deny.sample $RPM_BUILD_ROOT/var/spool/cron/deny
install -m 600 sample.root $RPM_BUILD_ROOT/etc/crontab
install -d $RPM_BUILD_ROOT/etc/cron.d
install -d $RPM_BUILD_ROOT/etc/cron.hourly
install -d $RPM_BUILD_ROOT/etc/cron.daily
install -d $RPM_BUILD_ROOT/etc/cron.weekly
install -d $RPM_BUILD_ROOT/etc/cron.monthly
install -d $RPM_BUILD_ROOT/usr/lib/cron
install -o root -g root -m744 run-crons $RPM_BUILD_ROOT/usr/lib/cron
install -d $RPM_BUILD_ROOT/etc/init.d
cp %{SOURCE1} $RPM_BUILD_ROOT/etc/init.d/cron
chmod 744 $RPM_BUILD_ROOT/etc/init.d/cron
ln -sf ../../etc/init.d/cron $RPM_BUILD_ROOT/usr/sbin/rccron

%preun
%stop_on_removal cron

%post
#
# Initialize runlevel links
#
%{fillup_and_insserv -psy cron CRON}
#
# Move the old crontabs to the new location
if [ -d var/cron ] ; then
	cp -pr var/cron/* var/spool/cron
	rm -rf var/cron
	cp etc/crontab etc/crontab.old
	sed "s|/var/cron|/var/spool/cron|g" < etc/crontab.old > etc/crontab
fi
#
grep -v "#" etc/crontab 2> /dev/null | grep /usr/lib/cron/run-crons > /dev/null || {
mkdir -p var/adm/notify/messages
cat << EOT > var/adm/notify/messages/cron
Hallo (english text below),
Unter /etc befinden sich Verzeichnisse namens cron.hourly, cron.daily,
cron.weekly und cron.monthly.  Skripte und Programme die in diesen
Verzeichnissen abgelegt werden, sollen automatisch gestartet werden.  Damit
dies geschieht, tragen Sie bitte folgendes in Ihre /etc/crontab ein:
*/15 * * * *   root  test -x /usr/lib/cron/run-crons && /usr/lib/cron/run-crons
Beachten Sie auch bitte, da das Skript /root/bin/cron.daily in
/etc/cron.daily/aaa_base umbenannt wurde.  Bitte entfernen Sie den Eintrag
auf der /etc/crontab.
Hello.
Under /etc you can find the directories cron.hourly, cron.daily,
cron.weekly and cron.monthly.  Scripts and programs, that are located
there shall be started automatically.  To make this work, please aadd the
following line to your /etc/crontab:
*/15 * * * *   root  test -x /usr/lib/cron/run-crons && /usr/lib/cron/run-crons
Please note, that /root/bin/cron.daily has moved to /etc/cron.daily/aaa_base.
Please remove the entry from your crontab.
Have a lot of fun...
                          Your SuSE Team
EOT
}
grep -v "#" var/spool/cron/tabs/root 2> /dev/null | grep cron.daily > /dev/null || exit 0
mkdir -p var/adm/notify/messages
cat << EOT > var/adm/notify/messages/crontab
(English translation is below.)
Bei Ihnen ist immer noch "cron.daily" in /var/spool/cron/tabs/root. Bitte
starten Sie als root "crontab -e" und loeschen Sie die Zeile, in der
"cron.daily" aufgerufen wird.
Alle Eintragungen in /var/spool/cron/tabs/root sind nun nach /etc/crontab
gewandert. Diese Datei hat ein extra Feld, in dem der Benutzer eingetragen
werden kann, unter dem der cron-Eintrag gestartet wird.
Damit kann man nun alle sysadm-Cronjobs (root,uucp,news) in einer Datei
eintragen und muss auch kein "su" dort eintragen.
Damit cron.daily nicht doppelt gestartet wird, muss man es aus der alten
Datei /var/spool/cron/tabs/root ueber "crontab -e" loeschen.
You still have "cron.daily" in /var/spool/cron/tabs/root. Please execute
"crontab -e" as user root and delete the line which starts "cron.daily".
Instead of distributing default crontab-entries in /var/spool/cron/tabs/root,
we now have a /etc/crontab file. That file has an additional entry which
contains the name of the user the script should be executed as.
So you can have all sysadm scripts (root,news,uucp) in on file, /etc/crontab.
EOT

%postun
%restart_on_update cron
%{insserv_cleanup}

%files
%dir /var/spool/cron
%dir /var/spool/cron/tabs
%dir /var/spool/cron/lastrun
%doc CHANGES CONVERSION FEATURES MAIL MANIFEST README THANKS
%config /etc/init.d/cron
%config(noreplace) /etc/crontab
%config(noreplace) /var/spool/cron/deny
%doc %{_mandir}/man1/crontab.1.gz
%doc %{_mandir}/man5/crontab.5.gz
%doc %{_mandir}/man8/cron.8.gz
%attr (4750,root,trusted) /usr/bin/crontab
%attr (755,root,root) /usr/sbin/cron
/usr/sbin/rccron
/usr/lib/cron
#%dir /etc/cron.d
#%dir /etc/cron.hourly
#%dir /etc/cron.daily
#%dir /etc/cron.weekly
#%dir /etc/cron.monthly

%changelog -n cron
* Mon May 29 2006 - kssingvo@suse.de
- fixed priviledge escalation bug CVE-2006-2607 (bugzilla#178863)
* Wed Nov 02 2005 - mmj@suse.de
- change sendmail arguments from "%%s -FCronDaemon -odi -oem %%s" to
  "%%s -FCronDaemon -odi -oem -oi %%s" [FATE #251]
* Fri Apr 15 2005 - hhetter@suse.de
- added cron-timing patch to fix cron jobs which are started
  too early (#58725)
* Tue Apr 06 2004 - kukuk@suse.de
- fix permissions of crontab
* Fri Mar 26 2004 - thomas@suse.de
- cosmetic changes in spec file (inspired by mmj)
- ironed out hunk shift due to changed line offset in laus
  patch
* Wed Mar 24 2004 - thomas@suse.de
- made LAuS support work on x86_64
* Tue Mar 23 2004 - thomas@suse.de
- added LAuS patch
* Thu Oct 02 2003 - fehr@suse.de
- fix wrong nice level of cron scripts (#31961)
* Thu Sep 18 2003 - ro@suse.de
- fix typo in run-crons (#31216)
* Tue Aug 26 2003 - mmj@suse.de
- Don't do it all in the 0'th hour, but the 4th
* Sat Aug 16 2003 - kukuk@suse.de
- Modify /etc/crontab only if we need to move cron directory
- Try to restart daemon on update
* Thu Jul 03 2003 - fehr@suse.de
- fix bug in handling of monthly script in /usr/lib/cron/run-crons
  (#27704)
- adapt sigcld handling for new kernel (#26011)
* Tue May 27 2003 - sndirsch@suse.de
- /usr/lib/cron/run-crons: added missing "-n" to specify nice level
* Tue May 06 2003 - fehr@suse.de
- Fix bug in quoting patch (#26675)
* Wed Apr 16 2003 - coolo@suse.de
- use BuildRoot
* Mon Mar 24 2003 - fehr@suse.de
- Add improved version of cron_number_check.patch from Gernot Payer
* Thu Mar 20 2003 - fehr@suse.de
- Fix wrong check for number, thanks to Gernot Payer <gpayer@suse.de>
  (#25680)
* Fri Feb 28 2003 - fehr@suse.de
- Fix quoting problem with %% in crontab, thanks to Klaus G. Wagner
  <kgw@suse.de> (#17713)
* Thu Feb 13 2003 - mmj@suse.de
- Do not own /etc/cron.d* since we might want to use other cron
  versions.
* Tue Nov 05 2002 - ro@suse.de
- fixed bogus self-provides
* Tue Nov 05 2002 - ro@suse.de
- fixed typo in run-crons script (ouput->output) (#21497)
* Thu Aug 15 2002 - fehr@suse.de
- add PreReq tag to spec file
* Mon Aug 05 2002 - kukuk@suse.de
- Use $time instead of xntpd
- Make sendmail/postfix "Should-Start"
* Wed Jul 03 2002 - draht@suse.de
- crontab(1) must not leak fd for /var/spool/cron/deny and/or
  /var/spool/cron/allow to the user's editor (security).
* Thu Apr 25 2002 - fehr@suse.de
- added newline to run-cron output (#15796)
* Fri Mar 01 2002 - egmont@suselinux.hu
- fix month/day interval in manpage
* Thu Feb 21 2002 - ro@suse.de
- logger is in /bin, adapt run-crons script
* Mon Feb 04 2002 - fehr@suse.de
- fix reload option of init-script (#13026)
* Thu Jan 24 2002 - ro@suse.de
- modified fillup_and_insserv call (perl-hack not needed here)
* Fri Jan 18 2002 - ro@suse.de
- fixed initscript comments
* Thu Jan 10 2002 - ro@suse.de
- removed test for CRON variable from init script
* Wed Dec 12 2001 - fehr@suse.de
- fix wrong sigchld handling (thanks to Philip Willoughby)
- changed to new init script handling
* Fri Sep 28 2001 - ro@suse.de
- removed duplicate trap in run-crons (#11472)
* Thu Sep 13 2001 - ro@suse.de
- updated run-crons (feedback from volker_apelt, thanks)
* Fri Sep 07 2001 - schwab@suse.de
- Instead of closing std{in,out,err} redirect them to /dev/null.
* Wed Aug 15 2001 - fehr@suse.de
- add log messages when one of the /etc/cron/cron.* scripts fails
  (thanks for suggestion by Steffen Dettmer)
* Mon May 07 2001 - draht@suse.de
- Added security patch for a wrong setuid() call.
* Tue Apr 24 2001 - ro@suse.de
- added rc-link
* Mon Apr 23 2001 - ro@suse.de
- added updated startscript and rc.config variable
* Thu Apr 12 2001 - werner@suse.de
- Close stdin, stdout, and stderr on forking of the daemon.
* Wed Feb 14 2001 - fehr@suse.de
- add patch to prevent buffer overflow with usernames longer than
  19 characters
* Tue Feb 06 2001 - fehr@suse.de
- Make it compile with new glibc
- remove calls to fax utilities and texpire from default crontab
* Tue Dec 12 2000 - werner@suse.de
- Add cron.hourly because we provide /etc/cron.hourly/
- Remove lock files not at same time but with a quater offset
- Don't run *.rpmorig, *.rpmnew, *.rmpsave, *.swap, *.bak, *~, #*
- Don run a script if it is already running
- Remove `echo' to enable DTS patch of Thomas
* Fri Dec 08 2000 - fehr@suse.de
- fix bug introduced in last change
* Mon Nov 20 2000 - fehr@suse.de
- add security patch from Daniel Jacobowitz to cron
- prevent cron.daily called twice when changing from DST to normal (#998)
* Wed Nov 15 2000 - fehr@suse.de
- add most of the patches of Chris D. Faulhaber (jedgar@fxp.org) (#4249)
* Tue Sep 05 2000 - fehr@suse.de
- make sematic of cron.monthly clearer. It is now executed on the
  first check in run-crons executed in a month but at most once
  per month. Older semantic was to execute every 30 days which
  resulted in being called twice per month when month has 31 days
  and first execution was on 1st day of month. (#3850)
* Fri Jul 21 2000 - fehr@suse.de
- fix the use of ifdef __linux__ (everywhere else __linux is used)
* Wed May 31 2000 - fehr@suse.de
- Start script with "nice -15"
* Mon May 22 2000 - kukuk@suse.de
- Fix post install section
* Tue May 16 2000 - kukuk@suse.de
- Move /var/cron -> /var/spool/cron (FHS 2.1)
* Sun Feb 27 2000 - kukuk@suse.de
- Move /usr/man -> /usr/share/man
* Mon Jan 24 2000 - uli@suse.de
- added -D__linux to cope with gcc 2.95
* Thu Dec 02 1999 - bs@suse.de
- removed CDR_PROG section from run-crons. this leads to problems in
  some network environments.
* Mon Sep 20 1999 - ro@suse.de
- added Requires smtp_daemon
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Mon Aug 30 1999 - kukuk@suse.de
- always use fork instead of vfork
* Fri Aug 27 1999 - fehr@suse.de
- prevent sendmail from being called as root
* Thu Aug 26 1999 - fehr@suse.de
- fixed some possible buffer overflow exploits
* Fri Jul 23 1999 - bs@suse.de
- redirect stderr of apm call to /dev/null
* Thu Jul 15 1999 - bs@suse.de
- don't run cron jobs via run-cron if
  o  a cd writer is running
  o  laptop is AC-offline
- /etc/crontab:
  o  don't log every start of run-crons
  o  run faxclean only once a day
* Mon Mar 29 1999 - ro@suse.de
- added cron.d feature from debian-cron
* Mon Feb 01 1999 - bs@suse.de
- merged beta and stable version
- added entries in crontab to delete lastrun files, to let cronjobs be started
  at night.
* Fri Jan 08 1999 - bs@suse.de
- changed run-crons to work around finds 'strange behavior'
* Fri Dec 18 1998 - ro@suse.de
- use SIGCHLD instead of SIGCLD
* Tue Dec 15 1998 - bs@suse.de
- fixed xargs in run-crons
* Mon Dec 14 1998 - bs@suse.de
- fixed bug in run-crons
* Mon Dec 14 1998 - bs@suse.de
- added /etc/cron.* feature.
* Tue Nov 17 1998 - bs@suse.de
- added texpire to crontab.
- use noreplace for config files.
* Thu Sep 10 1998 - bs@suse.de
- fixed problem with non existing var/cron/tabs/root.
* Mon Sep 07 1998 - bs@suse.de
- fixed check for /var/cron/tabs/root in %%post section
* Mon Jul 07 1997 - florian@suse.de
- warn if cron.daily is still in /var/cron/tabs/root
- start cron.daily 10 minutes earlier, so that duplicate
  entries don't overlap :-(
* Thu Jun 05 1997 - florian@suse.de
- use /etc/crontab instead of /var/cron/tabs/root
* Fri May 16 1997 - bs@suse.de
- removed *.new -> orig stuff behavior, since is not neded for rpm.
* Wed Apr 30 1997 - florian@suse.de
- fix screen output ifrom ALLOW_FILE to DENY_FILE
- do not include syslog.c anymore, libc is fixed
- disable debugging compile time switch
- add some security patches
* Thu Feb 27 1997 - bs@suse.de
  added crontab entries for hylafax.
* Wed Jan 22 1997 - florian@suse.de
- syslogging works even if syslogd is restarted
* Thu Jan 02 1997 - bs@suse.de
- beautified man page
- store crontab.root.new in /root instead of /tmp
* Thu Jan 02 1997 - bs@suse.de
  atrun aus crontab fr root rausgenommen.
